- Qt 5.15
- Qt 3D
- C++ Classes
- QMorphPhongMaterial
- Qt 5.15.11 Reference Documentation

# QMorphPhongMaterial Class

class Qt3DExtras::QMorphPhongMaterial

The QMorphPhongMaterial class provides a default implementation of the phong lighting effect. More...

Header: | #include <QMorphPhongMaterial>
qmake: | QT += 3dextras
Since: | Qt 5.7
Inherits: | Qt3DRender::QMaterial

This class was introduced in Qt 5.7.

- List of all members, including inherited members

## Properties

- ambient : QColor
- diffuse : QColor
- interpolator : float

- shininess : float
- specular : QColor

## Public Functions

virtual | ~QMorphPhongMaterial()
QColor | ambient() const
QColor | diffuse() const
float | interpolator() const
float | shininess() const
QColor | specular() const

## Public Slots

void | setAmbient(const QColor &ambient)
void | setDiffuse(const QColor &diffuse)
void | setInterpolator(float interpolator)
void | setShininess(float shininess)
void | setSpecular(const QColor &specular)

## Signals

void | ambientChanged(const QColor &ambient)
void | diffuseChanged(const QColor &diffuse)
void | interpolatorChanged(float interpolator)
void | shininessChanged(float shininess)
void | specularChanged(const QColor &specular)

## Detailed Description

The phong lighting effect is based on the combination of 3 lighting components ambient, diffuse and specular. The relative strengths of these components are controlled by means of their reflectivity coefficients which are modelled as RGB triplets:

- Ambient is the color that is emitted by an object without any other light source.
- Diffuse is the color that is emitted for rought surface reflections with the lights.
- Specular is the color emitted for shiny surface reflections with the lights.
- The shininess of a surface is controlled by a float property.

This material uses an effect with a single render pass approach and performs per fragment lighting. Techniques are provided for OpenGL 2, OpenGL 3 or above as well as OpenGL ES 2.

## Property Documentation

### ambient : QColor

Holds the ambient color.

Access functions:

QColor | ambient() const
void | setAmbient(const QColor &ambient)

Notifier signal:

void | ambientChanged(const QColor &ambient)

### diffuse : QColor

Holds the diffuse color.

Access functions:

QColor | diffuse() const
void | setDiffuse(const QColor &diffuse)

Notifier signal:

void | diffuseChanged(const QColor &diffuse)

### interpolator : float

Contains the interpolation method of the Phong lighting effect.

Access functions:

float | interpolator() const
void | setInterpolator(float interpolator)

Notifier signal:

void | interpolatorChanged(float interpolator)

### shininess : float

Holds the shininess exponent.

Access functions:

float | shininess() const
void | setShininess(float shininess)

Notifier signal:

void | shininessChanged(float shininess)

### specular : QColor

Holds the specular color.

Access functions:

QColor | specular() const
void | setSpecular(const QColor &specular)

Notifier signal:

void | specularChanged(const QColor &specular)

## Member Function Documentation

### `[virtual]` QMorphPhongMaterial::~QMorphPhongMaterial()

Destroys the QMorphPhongMaterial.